package at.ac.tuwien.dbai.alternation.examples;
import at.ac.tuwien.dbai.alternation.examples.GraphGame.Position;


public class AcyclicGeographic {
	private at.ac.tuwien.dbai.alternation.runtime.ATM<Inputtape,Worktape> atm;

	public class Inputtape {
		Graph<Position> gameBoard;
		Graph.Node<Position> startNode;

		private Inputtape(Graph<Position> gameBoard,Graph.Node<Position> startNode) {
			super();
			this.gameBoard=gameBoard;
			this.startNode=startNode;
		}
	}

    public class Worktape implements at.ac.tuwien.dbai.alternation.runtime.InterfaceWorktape<Inputtape> {
    	public Graph.Node<Position> position;

    	private Worktape(){
    		super();
    	}

    	private Worktape(Worktape worktape) {
    		this.position = worktape.position;
    	}

    	public void reset(Inputtape atmInputtape) {

    		this.position=null;
    		this.position = atmInputtape.startNode;
    	}

    	public Worktape clone(){
    		return new Worktape(this);
    	};

    	public boolean equals( Object o ) {
        	if ( o == null ) return false;
            if (! o.getClass().equals(getClass()) ) return false;
            Worktape tape2=(Worktape) o;
    		if(this.position==null){
    			if(!(tape2.position==null)) return false;
    		} else {
    		  	if(!this.position.equals(tape2.position)) return false;
    		}
            return true;
    	}

    	@Override
    	public int hashCode() {
    		final int prime = 31;
    		int result = 1;


    		result = prime * result + ((position == null) ? 0 : position.hashCode());

    		return result;
    	}

    	public String toString() {
    		StringBuffer ausgabe= new StringBuffer();

    		if (position==null) {
    			ausgabe.append("position=null; ");
    		} else {
    			ausgabe.append("position=("+((Object)position).toString()+"); ");
    		}

    		return ausgabe.toString();
    	}
    }

    private class Player1 extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		for (Graph.Node<Position> node : atmWorktape.position.getChildren()){
    		                {
    		                    atmWorktape.position=node;
    		                }
    		atmResultTuple.add((byte)1,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    		            }
    		return atmResultTuple;
    	}
    }

    private class Player2 extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		for (Graph.Node<Position> node : atmWorktape.position.getChildren()){
    		                {
    		                    atmWorktape.position=node;
    		                }
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    		            }
    		return atmResultTuple;
    	}
    }

    public boolean compute(Graph<Position> gameBoard,Graph.Node<Position> startNode) {

    	Inputtape atmInput = new Inputtape(gameBoard,startNode);
    	if (this.atm==null) {
    		Worktape atmWork = new  Worktape();
    		java.util.Map<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>> atmStates = new java.util.HashMap<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>>();

    		atmStates.put((byte)1,new Player2());
    		atmStates.put((byte)0,new Player1());

    		this.atm = new at.ac.tuwien.dbai.alternation.runtime.ATMcyclic<Inputtape,Worktape>(atmStates, atmWork, (byte)0);
        }
        return atm.compute(atmInput);
    }

	public at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> getComputationTree(){
		at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> cT=this.atm.getComputationTree();
		cT.setName("AcyclicGeographic");
		cT.setStateIdToName((byte)1, "Player2");
		cT.setNameToStateId("Player2",(byte) 1);
		cT.setStateIdToName((byte)0, "Player1");
		cT.setNameToStateId("Player1",(byte) 0);

		return cT;
	}
}