package at.ac.tuwien.dbai.alternation.examples;


public class BipartiteArgumentationCredulousElementary {
	private at.ac.tuwien.dbai.alternation.runtime.ATM<Inputtape,Worktape> atm;

	public class Inputtape {
		BipartiteGraph.Node<Integer> x;
		BipartiteGraph<Integer> AF;

		private Inputtape(BipartiteGraph.Node<Integer> x,BipartiteGraph<Integer> AF) {
			super();
			this.x=x;
			this.AF=AF;
		}
	}

    public class Worktape implements at.ac.tuwien.dbai.alternation.runtime.InterfaceWorktape<Inputtape> {
    	public BipartiteGraph.Node<Integer> argument;
    	public BipartiteGraph.Node<Integer> guard;

    	private Worktape(){
    		super();
    	}

    	private Worktape(Worktape worktape) {
    		this.argument = worktape.argument;
    		this.guard = worktape.guard;
    	}

    	public void reset(Inputtape atmInputtape) {

    		this.argument=null;
    		this.guard=null;
    		this.argument = atmInputtape.x;
    		this.guard = null;
    	}

    	public Worktape clone(){
    		return new Worktape(this);
    	};

    	public boolean equals( Object o ) {
        	if ( o == null ) return false;
            if (! o.getClass().equals(getClass()) ) return false;
            Worktape tape2=(Worktape) o;
    		if(this.argument==null){
    			if(!(tape2.argument==null)) return false;
    		} else {
    		  	if(!this.argument.equals(tape2.argument)) return false;
    		}
    		if(this.guard==null){
    			if(!(tape2.guard==null)) return false;
    		} else {
    		  	if(!this.guard.equals(tape2.guard)) return false;
    		}
            return true;
    	}

    	@Override
    	public int hashCode() {
    		final int prime = 31;
    		int result = 1;


    		result = prime * result + ((argument == null) ? 0 : argument.hashCode());
    		result = prime * result + ((guard == null) ? 0 : guard.hashCode());

    		return result;
    	}

    	public String toString() {
    		StringBuffer ausgabe= new StringBuffer();

    		if (argument==null) {
    			ausgabe.append("argument=null; ");
    		} else {
    			ausgabe.append("argument=("+((Object)argument).toString()+"); ");
    		}


    		if (guard==null) {
    			ausgabe.append("guard=null; ");
    		} else {
    			ausgabe.append("guard=("+((Object)guard).toString()+"); ");
    		}

    		return ausgabe.toString();
    	}
    }

    private class ForallAttackers extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		if(atmWorktape.argument==atmWorktape.guard){return at.ac.tuwien.dbai.alternation.runtime.ResultTuple.ACCEPT;}
    				atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		for (BipartiteGraph.Node<Integer> attacker : atmWorktape.argument.getParents()){
    						{
    							atmWorktape.argument=attacker;
    						}
    		atmResultTuple.add((byte)1,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    					}
    		return atmResultTuple;
    	}
    }

    private class ExistsGuard extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		{}
    		atmResultTuple.add((byte)2,atmWorktape);
    		atmWorktape=atmWorktape2.clone();

    					{
    							atmWorktape.guard=atmWorktape.argument;
    					}
    		atmResultTuple.add((byte)2,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    		return atmResultTuple;
    	}
    }

    private class ExistsDefender extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		if(atmWorktape.argument==atmWorktape.guard){return at.ac.tuwien.dbai.alternation.runtime.ResultTuple.ACCEPT;}
    				atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		for (BipartiteGraph.Node<Integer> defender : atmWorktape.argument.getParents()){
    						{
    							atmWorktape.argument=defender;
    						}
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    					}
    					for (BipartiteGraph.Node<Integer> defender : atmWorktape.argument.getParents()){
    						{
    							atmWorktape.guard=atmWorktape.argument;
    							atmWorktape.argument=defender;
    						}
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    					}
    		return atmResultTuple;
    	}
    }

    public boolean compute(BipartiteGraph.Node<Integer> x,BipartiteGraph<Integer> AF) {

    	Inputtape atmInput = new Inputtape(x,AF);
    	if (this.atm==null) {
    		Worktape atmWork = new  Worktape();
    		java.util.Map<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>> atmStates = new java.util.HashMap<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>>();

    		atmStates.put((byte)1,new ExistsGuard());
    		atmStates.put((byte)0,new ForallAttackers());
    		atmStates.put((byte)2,new ExistsDefender());

    		this.atm = new at.ac.tuwien.dbai.alternation.runtime.ATMcyclic<Inputtape,Worktape>(atmStates, atmWork, (byte)0);
        }
        return atm.compute(atmInput);
    }

	public at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> getComputationTree(){
		at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> cT=this.atm.getComputationTree();
		cT.setName("BipartiteArgumentationCredulousElementary");
		cT.setStateIdToName((byte)1, "ExistsGuard");
		cT.setNameToStateId("ExistsGuard",(byte) 1);
		cT.setStateIdToName((byte)0, "ForallAttackers");
		cT.setNameToStateId("ForallAttackers",(byte) 0);
		cT.setStateIdToName((byte)2, "ExistsDefender");
		cT.setNameToStateId("ExistsDefender",(byte) 2);

		return cT;
	}
}