package at.ac.tuwien.dbai.alternation.examples;

import at.ac.tuwien.dbai.alternation.examples.BipartiteArgumentationCredulous.Worktape;
import at.ac.tuwien.dbai.alternation.runtime.ComputationTree;

public class BipartiteArgumentationTest {

	public static void main(String[] args) {
		BipartiteGraph<Integer> graph=new BipartiteGraph<Integer>();

		int n=4;
		for (int i=0; i<n; i++){;
			graph.addNodeToSetA(i);
		}
		int m=4;
		for (int i=10; i<10+m; i++){;
			graph.addNodeToSetB(i);
		}

		graph.addEdge(0,10);
		graph.addEdge(10,1);
		graph.addEdge(1,11);
		graph.addEdge(11,0);

		int argument=0;

		BipartiteArgumentationCredulous atm = new BipartiteArgumentationCredulous();
		CoBipartiteArgumentationCredulous atm2 = new CoBipartiteArgumentationCredulous();
		BipartiteArgumentationSceptical atm3 = new BipartiteArgumentationSceptical();
		BipartiteArgumentationCredulousElementary atm4 = new BipartiteArgumentationCredulousElementary();

		System.out.println("credulous: " + atm.compute(graph.get(argument), graph));
		ComputationTree<Worktape> cT = atm.getComputationTree();
		System.out.println("#ComputationNodes: "+cT.size());

		System.out.println("credulous-elementary: " + atm4.compute(graph.get(argument), graph));
		System.out.println("#ComputationNodes: "+ atm4.getComputationTree().size());

		System.out.println("co-credulous: " + atm2.compute(graph.get(argument), graph));

		System.out.println("sceptical: " + atm3.compute(graph.get(argument), graph));
	}
}
