package at.ac.tuwien.dbai.alternation.examples;


public class CoBipartiteArgumentationCredulous {
	private at.ac.tuwien.dbai.alternation.runtime.ATM<Inputtape,Worktape> atm;

	public class Inputtape {
		BipartiteGraph.Node<Integer> x;
		BipartiteGraph<Integer> AF;

		private Inputtape(BipartiteGraph.Node<Integer> x,BipartiteGraph<Integer> AF) {
			super();
			this.x=x;
			this.AF=AF;
		}
	}

    public class Worktape implements at.ac.tuwien.dbai.alternation.runtime.InterfaceWorktape<Inputtape> {
    	public BipartiteGraph.Node<Integer> argument;

    	private Worktape(){
    		super();
    	}

    	private Worktape(Worktape worktape) {
    		this.argument = worktape.argument;
    	}

    	public void reset(Inputtape atmInputtape) {

    		this.argument=null;
    		this.argument = atmInputtape.x;
    	}

    	public Worktape clone(){
    		return new Worktape(this);
    	};

    	public boolean equals( Object o ) {
        	if ( o == null ) return false;
            if (! o.getClass().equals(getClass()) ) return false;
            Worktape tape2=(Worktape) o;
    		if(this.argument==null){
    			if(!(tape2.argument==null)) return false;
    		} else {
    		  	if(!this.argument.equals(tape2.argument)) return false;
    		}
            return true;
    	}

    	@Override
    	public int hashCode() {
    		final int prime = 31;
    		int result = 1;


    		result = prime * result + ((argument == null) ? 0 : argument.hashCode());

    		return result;
    	}

    	public String toString() {
    		StringBuffer ausgabe= new StringBuffer();

    		if (argument==null) {
    			ausgabe.append("argument=null; ");
    		} else {
    			ausgabe.append("argument=("+((Object)argument).toString()+"); ");
    		}

    		return ausgabe.toString();
    	}
    }

    private class ExistsAttacker extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, false);
    		atmWorktape2=atmWorktape.clone();
    		for (BipartiteGraph.Node<Integer> attacker : atmWorktape.argument.getParents()){
    						{
    							atmWorktape.argument=attacker;
    						}
    		atmResultTuple.add((byte)1,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    					}
    		return atmResultTuple;
    	}
    }

    private class ForallDefenders extends at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>  {

    	public at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> compute(Worktape atmWorktape) {
    		at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape> atmResultTuple;
    		Worktape atmWorktape2;
    		atmResultTuple = new at.ac.tuwien.dbai.alternation.runtime.ResultTuple<Worktape>(false, false, true);
    		atmWorktape2=atmWorktape.clone();
    		for (BipartiteGraph.Node<Integer> defender : atmWorktape.argument.getParents()){
    						{
    							atmWorktape.argument=defender;
    						}
    		atmResultTuple.add((byte)0,atmWorktape);
    		atmWorktape=atmWorktape2.clone();
    					}
    		return atmResultTuple;
    	}
    }

    public boolean compute(BipartiteGraph.Node<Integer> x,BipartiteGraph<Integer> AF) {

    	Inputtape atmInput = new Inputtape(x,AF);
    	if (this.atm==null) {
    		Worktape atmWork = new  Worktape();
    		java.util.Map<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>> atmStates = new java.util.HashMap<Byte,at.ac.tuwien.dbai.alternation.runtime.State<Inputtape,Worktape>>();

    		atmStates.put((byte)1,new ForallDefenders());
    		atmStates.put((byte)0,new ExistsAttacker());

    		this.atm = new at.ac.tuwien.dbai.alternation.runtime.ATMcyclic<Inputtape,Worktape>(atmStates, atmWork, (byte)0);
        }
        return atm.compute(atmInput);
    }

	public at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> getComputationTree(){
		at.ac.tuwien.dbai.alternation.runtime.ComputationTree<Worktape> cT=this.atm.getComputationTree();
		cT.setName("CoBipartiteArgumentationCredulous");
		cT.setStateIdToName((byte)1, "ForallDefenders");
		cT.setNameToStateId("ForallDefenders",(byte) 1);
		cT.setStateIdToName((byte)0, "ExistsAttacker");
		cT.setNameToStateId("ExistsAttacker",(byte) 0);

		return cT;
	}
}