package at.ac.tuwien.dbai.alternation.examples;

import java.util.List;

import at.ac.tuwien.dbai.alternation.runtime.ComputationNode;
import at.ac.tuwien.dbai.alternation.runtime.ComputationTree;


public class TicTacToeTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		TicTacToe atm = new TicTacToe();
		byte[] game = new byte[]{0,0,0,0,1,0,0,2,0};
		System.out.println(atm.compute(game,true));
		System.out.println("#ComputationNodes: "+ atm.getComputationTree().size());
		ComputationTree<TicTacToe.Worktape> cT=atm.getComputationTree();
		if (cT.size()<50) System.out.println(atm.getComputationTree());
		drawTree(cT);
	}
	
	public static void drawTree(ComputationTree<TicTacToe.Worktape> cT){
		drawNode(cT,cT.getRoot());
	}

	public static void drawNode(ComputationTree<TicTacToe.Worktape> cT, ComputationNode<TicTacToe.Worktape> node){
		List<ComputationNode<TicTacToe.Worktape>> childs=cT.getChildren(node);
			
			if (childs==null){//halting state
				if(cT.get(node)) {//winning position
					for(int i=0;i<3;i++){
						System.out.print(node.getWorktape().paper[i] + ", ");
					}
					System.out.println();
					for(int i=3;i<6;i++){
						System.out.print(node.getWorktape().paper[i] + ", ");
					}
					System.out.println();
					for(int i=6;i<8;i++){
						System.out.print(node.getWorktape().paper[i] + ", ");
					}
					System.out.println(node.getWorktape().paper[8] + ";\n");
				}

			} else {
				if (node.isAllQuantified()){				
					for (ComputationNode<TicTacToe.Worktape> child : childs){
						drawNode(cT,child);
					}
				} else {
					for (ComputationNode<TicTacToe.Worktape> child : childs){
						if (cT.get(child).equals(true)){
							drawNode(cT,child);
						}
					}
				}
			}
	}
}
